//+------------------------------------------------------------------+
//|                                                   Magic_exp1.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|   CPositionVirtualMagic                           |
//+------------------------------------------------------------------+
struct SPositionVirtualMagic
  {
   double            volume; //  . 
   ENUM_POSITION_TYPE type;  //    . 
  };
//+------------------------------------------------------------------+
//|               |
//+------------------------------------------------------------------+
class CPositionVirtualMagic
  {
protected:
   SPositionVirtualMagic pvm;
public:
   double               cVOLUME(){return(pvm.volume);}
   //     
   ENUM_POSITION_TYPE   cTYPE(){return(pvm.type);}
   //       
   bool              PositionVirtualMagic(ulong Magic,
                                          string symbol,
                                          datetime CurrentTime);
   //   . ,     . 
private:
   void              prHistory_Deals(ulong &buf[],int HTD); 
   //   
  };
//+------------------------------------------------------------------+
//|   . ,  true   . |
//+------------------------------------------------------------------+
bool  CPositionVirtualMagic::PositionVirtualMagic(ulong Magic,
                                                  string symbol,
                                                  datetime CurrentTime)
  {
   int DIGITS=(int)-log10(SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP));
   if(DIGITS<0)DIGITS=0;
   ulong Dticket=0;
   int History_Total_Deals=-1;
   double volume=0,volume_BUY=0,volume_SELL=0;
   ulong DTicketbuf[];

   do
     {
      if(HistorySelect(0,TimeCurrent()))
        {
         History_Total_Deals=HistoryDealsTotal();
         prHistory_Deals(DTicketbuf,History_Total_Deals);
        }
      HistorySelect(0,TimeCurrent());  
     }
   while(History_Total_Deals!=HistoryDealsTotal());

   for(int t=0;t<History_Total_Deals;t++)
     {
      Dticket=DTicketbuf[t];
      if(HistoryDealSelect(Dticket))
        {
         if(HistoryDealGetInteger(Dticket,DEAL_TIME)>=CurrentTime)
           {
            if(HistoryDealGetInteger(Dticket,DEAL_MAGIC)==Magic)
              {
               if(HistoryDealGetInteger(Dticket,DEAL_TYPE)==DEAL_TYPE_BUY)
                 {
                  volume_BUY+=HistoryDealGetDouble(Dticket,DEAL_VOLUME);
                 }
               else
                 {
                  if(HistoryDealGetInteger(Dticket,DEAL_TYPE)==DEAL_TYPE_SELL)
                    {
                     volume_SELL+=HistoryDealGetDouble(Dticket,DEAL_VOLUME);
                    }
                 }
              }
           }
        }
      else{HistorySelect(0,TimeCurrent());t--;}
      //         
     }
   volume=NormalizeDouble(volume_BUY-volume_SELL,DIGITS);
   if(volume<0)pvm.type=POSITION_TYPE_SELL;
   else
     {
      if(volume>0)pvm.type=POSITION_TYPE_BUY;
     }
   pvm.volume=fabs(volume);
   if(pvm.volume==0)return(false);
   else return(true);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
void  CPositionVirtualMagic::prHistory_Deals(ulong &buf[],int HTD)
  {
   ArrayResize(buf,HTD);
   for(int t=0;t<HTD;t++)
     {
      buf[t]=HistoryDealGetTicket(t);
     }
  }
//+------------------------------------------------------------------+
//|                |
//+------------------------------------------------------------------+
class CProvision
  {
protected:
   MqlTradeRequest   trades;//      OrderSend  
public:
   int               TYPE(const double &v[]); //  ,     
   double            pricetype(int type);     //        
   double            SLtype(int type);        //       
   double            TPtype(int type);        //       
   long              spread();                //    
   ulong             SendOrder(ENUM_ORDER_TYPE type,double volume);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
ulong CProvision::SendOrder(ENUM_ORDER_TYPE type,double volume)
  {
   trades.action          =TRADE_ACTION_DEAL;      //   
   trades.magic           =magic;                  //   ( magic number)
   trades.symbol          =_Symbol;                //   
   trades.volume          =volume;                 //     
   trades.price           =pricetype((int)type);   //        
   trades.sl              =SLtype((int)type);      //  Stop Loss 
   trades.tp              =TPtype((int)type);      //  Take Profit          
   trades.deviation=(int)spread();        //      
   trades.type=type;                               //  
   trades.type_filling=ORDER_FILLING_FOK;
   if(OrderSend(trades,res)){return(res.retcode);}
   return(-1);
  }
//+------------------------------------------------------------------+
//|  ,                      |
//+------------------------------------------------------------------+
int CProvision::TYPE(const double &v[])
  {
   double t=v[0]-v[1];
   if(t==0.0)t=1.0;
   return((int)(0.5*t/fabs(t)+0.5));
  }
//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
double CProvision::pricetype(int type)
  {
   if(SymbolInfoTick(_Symbol,tick))
     {
      if(type==0)return(tick.ask);
      if(type==1)return(tick.bid);
     }
   return(-1);
  }
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
double CProvision::SLtype(int type)
  {
   if(SymbolInfoTick(_Symbol,tick))
     {
      if(type==0)return(tick.bid-SL*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
      if(type==1)return(tick.ask+SL*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
double CProvision::TPtype(int type)
  {
   if(SymbolInfoTick(_Symbol,tick))
     {
      if(type==0)return(tick.bid+TP*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
      if(type==1)return(tick.ask-TP*SymbolInfoDouble(Symbol(),SYMBOL_POINT));
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
long CProvision::spread()
  {
   return(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD));
  }
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+

//--- input parameters
input ulong              magic       =1;           // 
input int                SL          =300;         // 
input int                TP          =1000;        // 
input int                MA_Period   =25;          //  MA
input double             lot         =0.1;         //  
input int                MA_shift    =0;           //  
input ENUM_MA_METHOD     MA_smooth   =MODE_SMA;    //  
input ENUM_APPLIED_PRICE price       =PRICE_OPEN;  //   

//---    
int MA_handle,type_MA;
ulong rezult;
double v[2];
datetime  CurrentTime;//     

MqlTradeResult  res;   //      OrderSend
MqlTick         tick;  //      
CPositionVirtualMagic cpvm;
CProvision prov;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   CurrentTime=TimeCurrent();//     
//---   
   MA_handle=iMA(Symbol(),0,MA_Period,MA_shift,MA_smooth,price);
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(CopyBuffer(MA_handle,0,0,2,v)<=0)
     {Print("",magic," ");return;}
   type_MA=prov.TYPE(v); //  ,     

   if(cpvm.PositionVirtualMagic(magic,_Symbol,CurrentTime))//     
     {
      if((int)cpvm.cTYPE()!=type_MA)//    
        {
         Print("",magic,"     ",cpvm.cVOLUME(),
               "    ",(int)cpvm.cTYPE(),"  ",type_MA);
         //cpvm.cVOLUME() -   
         rezult=prov.SendOrder((ENUM_ORDER_TYPE)type_MA,cpvm.cVOLUME()+lot);//  
         if(rezult!=-1)Print("",magic,"   ",rezult," volume ",res.volume);
         else{Print("",magic,"",GetLastError()); return;}
        }
     }
   else //     
     {
      Print("",magic,"     ",cpvm.cVOLUME(),"    ",type_MA);
      rezult=prov.SendOrder((ENUM_ORDER_TYPE)type_MA,lot);//   
      if(rezult!=-1)Print("",magic,"   ",rezult," volume ",res.volume);
      else{Print("",magic,"",GetLastError()); return;}
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//text789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
//cod456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_12
